
const mongoose = require('mongoose').set('debug', false)
const Schema = mongoose.Schema;

mongoose.Promise = global.Promise;
mongoose.level = "F";

const tools = require('../tools/general');

// Resolving error Unknown modifier: $pushAll
mongoose.plugin(schema => {
  schema.options.usePushEach = true
});

const CatAISchema = new Schema({
  name: {
    type: String,
  },
  idapp: {
    type: String,
  },
  img: {
    type: String,
  },
  icon: {
    type: String,
  },
  color: {
    type: String,
  },
});

CatAISchema.statics.getAllCategories = function (callback) {
  CatAI.find(callback)
}

CatAISchema.statics.getCatAIById = function (id, callback) {
  CatAI.findById(id, callback);
}

CatAISchema.statics.getFieldsForSearch = function () {
  return [{ field: 'name', type: tools.FieldType.string }]
};

CatAISchema.statics.executeQueryTable = function (idapp, params) {
  return tools.executeQueryTable(this, idapp, params);
};

CatAISchema.statics.findAllIdApp = async function (idapp) {
  const myfind = { idapp };

  return await CatAI.find(myfind).sort({ name: 1 }).lean();
};

const CatAI = mongoose.model('CatAI', CatAISchema);

CatAI.createIndexes()
  .then(() => { })
  .catch((err) => { throw err; });


module.exports = CatAI;
